Index: extensions/dict_dcca_3gpp/add_avps.c
===================================================================
--- extensions/dict_dcca_3gpp/add_avps.c	(revision 1510)
+++ extensions/dict_dcca_3gpp/add_avps.c	(revision 1511)
@@ -64,5 +64,5 @@
 	};
 
-	/* Note: 3GPP-Charging-Id (2) type changed from OctetString to Unsigned32, */
+	/* Fix: 3GPP-Charging-Id (2) type changed from OctetString to Unsigned32, */
 	/* per 3GPP TS 29.061 clause 16.4.7.2/2 and packet dumps.           */
 	/* 3GPP-Charging-Id, Unsigned32, code 2, section 16.4.7             */
@@ -236,6 +236,6 @@
 
 	/* Note: 3GPP TS 29.061 V12.6.0 (2014-06) renamed                   */
-	/* 3GPP-CG-IPv6-Address (14) to 3GPP-CG-Ipv6-Address.               */
-	/* This rename was not applied.                                     */
+	/* 3GPP-CG-IPv6-Address (14) to 3GPP-CG-Ipv6-Address;               */
+	/* this rename was not applied.                                     */
 	/* 3GPP-CG-IPv6-Address (14) changed to Must M per contrib/3gpp.    */
 	/* 3GPP-CG-IPv6-Address, OctetString, code 14, section 16.4.7       */
@@ -253,6 +253,6 @@
 
 	/* Note: 3GPP TS 29.061 V12.6.0 (2014-06) renamed                   */
-	/* 3GPP-SGSN-IPv6-Address (15) to 3GPP-SGSN-Ipv6-Address.           */
-	/* This rename was not applied.                                     */
+	/* 3GPP-SGSN-IPv6-Address (15) to 3GPP-SGSN-Ipv6-Address;           */
+	/* this rename was not applied.                                     */
 	/* 3GPP-SGSN-IPv6-Address (15) changed to Must M per contrib/3gpp.  */
 	/* 3GPP-SGSN-IPv6-Address, OctetString, code 15, section 16.4.7     */
@@ -270,6 +270,6 @@
 
 	/* Note: 3GPP TS 29.061 V12.6.0 (2014-06) renamed                   */
-	/* 3GPP-GGSN-IPv6-Address (16) to 3GPP-GGSN-Ipv6-Address.           */
-	/* This rename was not applied.                                     */
+	/* 3GPP-GGSN-IPv6-Address (16) to 3GPP-GGSN-Ipv6-Address;           */
+	/* this rename was not applied.                                     */
 	/* 3GPP-GGSN-IPv6-Address (16) changed to Must M per contrib/3gpp.  */
 	/* 3GPP-GGSN-IPv6-Address, OctetString, code 16, section 16.4.7     */
@@ -287,6 +287,6 @@
 
 	/* Note: 3GPP TS 29.061 V12.6.0 (2014-06) renamed                   */
-	/* 3GPP-IPv6-DNS-Servers (17) to 3GPP-Ipv6-DNS-Servers.             */
-	/* This rename was not applied.                                     */
+	/* 3GPP-IPv6-DNS-Servers (17) to 3GPP-Ipv6-DNS-Servers;             */
+	/* this rename was not applied.                                     */
 	/* 3GPP-IPv6-DNS-Servers (17) changed to Must M per contrib/3gpp.   */
 	/* 3GPP-IPv6-DNS-Servers, OctetString, code 17, section 16.4.7      */
@@ -426,11 +426,10 @@
 
 	/* Note: 3GPP TS 29.061 table 9a does not define                    */
-	/* External-Identifier (28) for Diameter.                           */
+	/* External-Identifier (28) for Diameter; it is RADIUS only.        */
 	/* 3GPP TS 29.061 table 9b refers to 3GPP TS 29.336                 */
 	/* for External-Identifier (3111).                                  */
 	/*                                                                  */
-	/* External-Identifier (28) OctetString replaced by                 */
-	/* External-Identifier (3111) UTF8String.                           */
-
+	/* Change since freeDiameter 1.4.0.                                 */
+	/* Fix: Remove External-Identifier (28) OctetString.                */
 
 	/* TWAN-Identifier, OctetString, code 29, section 16.4.7            */
@@ -714,6 +713,6 @@
 
 	/* Note: 3GPP TS 29.061 V12.6.0 (2014-06) renamed                   */
-	/* MBMS-GGSN-IPv6-Address (917) to MBMS-GGSN-Ipv6-Address.          */
-	/* This rename was not applied.                                     */
+	/* MBMS-GGSN-IPv6-Address (917) to MBMS-GGSN-Ipv6-Address;          */
+	/* this rename was not applied.                                     */
 	/* MBMS-GGSN-IPv6-Address, OctetString, code 917, section 17.7.20   */
 	{
@@ -743,6 +742,6 @@
 
 	/* Note: 3GPP TS 29.061 V12.6.0 (2014-06) renamed                   */
-	/* MBMS-BMSC-SSM-IPv6-Address (919) to MBMS-BMSC-SSM-Ipv6-Address.  */
-	/* This rename was not applied.                                     */
+	/* MBMS-BMSC-SSM-IPv6-Address (919) to MBMS-BMSC-SSM-Ipv6-Address;  */
+	/* this rename was not applied.                                     */
 	/* MBMS-BMSC-SSM-IPv6-Address, OctetString, code 919, section 17.7.22 */
 	{
@@ -837,6 +836,6 @@
 
 	/* Note: 3GPP TS 29.061 V12.6.0 (2014-06) renamed                   */
-	/* MBMS-GW-SSM-IPv6-Address (925) to MBMS-GW-SSM-Ipv6-Address.      */
-	/* This rename was not applied.                                     */
+	/* MBMS-GW-SSM-IPv6-Address (925) to MBMS-GW-SSM-Ipv6-Address;      */
+	/* this rename was not applied.                                     */
 	/* MBMS-GW-SSM-IPv6-Address, OctetString, code 925, section 20.5a.3 */
 	{
@@ -1128,6 +1127,4 @@
 	};
 
-	/* Note: 3GPP TS 29.128 table 6.4.1-1 row Non-IP-Data (4315)        */
-	/* has type "Octetstring" instead of "OctetString".                 */
 	/* Non-IP-Data, OctetString, code 4315, section 6.4.19              */
 	{
@@ -1420,6 +1417,9 @@
 	};
 
-	/* Note: Name conflict with 3GPP TS 32.329 Sequence-Number (716).   */
-	/* Sequence-Number (1107) renamed to Sequence-Number-29.140 (1107). */
+	/* Note: Name conflict with 3GPP TS 29.329 Sequence-Number (716).   */
+	/* 3GPP TS 29.140 V6.1.0 (2005-06) allocated Sequence-Number (1107). */
+	/* 3GPP TS 29.329 V10.0.0 (2010-09) CR 0163 added Sequence-Number (716). */
+	/*                                                                  */
+	/* Fix: Sequence-Number (1107) renamed to Sequence-Number-29.140 (1107). */
 	/* Sequence-Number-29.140, Unsigned32, code 1107, section 6.3.10    */
 	{
@@ -1435,6 +1435,9 @@
 	};
 
-	/* Note: Name conflict with 3GPP TS 32.299 Recipient-Address (1201). */
-	/* Recipient-Address (1108) renamed to Recipient-Address-29.140 (1108). */
+	/* Note: Name conflict with 3GPP TS 32.299 Recipient-Address (1201); */
+	/* 3GPP TS 29.140 V6.1.0 (2005-06) allocated Recipient-Address (1108). */
+	/* 3GPP TS 32.299 V6.4.0 (2005-09) CR 0028 added Recipient-Address (1201). */
+	/*                                                                  */
+	/* Fix: Recipient-Address (1108) renamed to Recipient-Address-29.140 (1108). */
 	/* Recipient-Address-29.140, UTF8String, code 1108, section 6.3.11  */
 	{
@@ -1553,6 +1556,12 @@
 	};
 
-	/* Note: Name conflict with 3GPP TS 32.299 Status (2702).           */
-	/* Status (1116) renamed to Status-29.140 (1116).                   */
+	/* Note: Name conflict with 3GPP TS 32.299 V11.6.0 Status (2702).   */
+	/* 3GPP TS 32.299 V11.10.0 (2013-12) CR 0566 renamed                */
+	/* Status (2702) to Status-Code (2702).                             */
+	/* 3GPP TS 32.299 V11.14.0 (2014-12) CR 0617 renamed                */
+	/* Status-Code (2702) to Status-AS-Code (2702).                     */
+	/*                                                                  */
+	/* TODO: rename back to Status ?                                    */
+	/* Fix: Status (1116) renamed to Status-29.140 (1116).              */
 	/* Status-29.140, Grouped, code 1116, section 6.3.19                */
 	{
@@ -1677,5 +1686,6 @@
 	/* Time-Window (3818) in 3GPP TS 29.345 V12.1.0 (2014-12) predates  */
 	/* Time-Window (4204) in 3GPP TS 29.154 V13.1.0 (2016-03).          */
-	/* Time-Window (4204) renamed to Time-Window-29.154 (4204).         */
+	/*                                                                  */
+	/* Fix: Time-Window (4204) renamed to Time-Window-29.154 (4204).    */
 	/* Time-Window-29.154, Grouped, code 4204, section 5.3.5            */
 	{
@@ -3010,4 +3020,7 @@
 	};
 
+	/* Note: Name conflict with 3GPP TS 32.299 3GPP-PS-Data-Off-Status (4406). */
+	/* 3GPP TS 29.212 V14.3.0 (2017-03) CR 1559 added 3GPP-PS-Data-Off-Status (2847). */
+	/* 3GPP TS 32.299 V14.3.0 (2017-03) CR 0760 added 3GPP-PS-Data-Off-Status (4406). */
 	/* 3GPP-PS-Data-Off-Status, Enumerated, code 2847, section 5.3.133  */
 	{
@@ -5476,4 +5489,6 @@
 	/* Note: 3GPP TS 29.214 table 5.3.0.1 row IMS-Content-Identifier (563) */
 	/* missing M, assume MUST NOT.                                      */
+	/*                                                                  */
+	/* Fix: IMS-Content-Identifier (563) flag M MUST NOT.               */
 	/* IMS-Content-Identifier, OctetString, code 563, section 5.3.60    */
 	{
@@ -5491,4 +5506,6 @@
 	/* Note: 3GPP TS 29.214 table 5.3.0.1 row IMS-Content (564)         */
 	/* missing M, assume MUST NOT.                                      */
+	/*                                                                  */
+	/* Fix: IMS-Content (564) flag M MUST NOT.                          */
 	/* IMS-Content-Type, Enumerated, code 564, section 5.3.61           */
 	{
@@ -6408,4 +6425,7 @@
 	};
 
+	/* Note: Name conflict with 3GPP TS 29.329 User-Data (702).         */
+	/* 3GPP TS 29.229 V6.2.0 (2004-09) allocated User-Data (606).       */
+	/* 3GPP TS 29.329 V6.2.0 (2004-09) allocated User-Data (702).       */
 	/* User-Data, OctetString, code 606, section 6.3.7                  */
 	{
@@ -8142,4 +8162,7 @@
 	/* changed row SS-Status (1477) to be OctetString instead of Grouped. */
 	/* Clause 7.3.88 already described SS-Status (1147) as OctetString. */
+	/*                                                                  */
+	/* Change since freeDiameter 1.4.0.                                 */
+	/* Fix: SS-Status (1477) type changed from Grouped to OctetString.  */
 	/* SS-Status, OctetString, code 1477, section 7.3.88                */
 	{
@@ -8296,4 +8319,7 @@
 	/* Note: 3GPP TS 29.272 V12.4.0 (2014-03) renamed                   */
 	/* Call-Barring-Infor-List (1488) to Call-Barring-Info (1488).      */
+	/*                                                                  */
+	/* Change since freeDiameter 1.4.0.                                 */
+	/* Fix: Call-Barring-Infor-List (1488) renamed to Call-Barring-Info (1488). */
 	/* Call-Barring-Info, Grouped, code 1488, section 7.3.101           */
 	{
@@ -8466,5 +8492,7 @@
 	/* Note: 3GPP TS 29.272 table 7.3.1/1 row MME-Location-Information (1600) */
 	/* incorrectly has a space instead of hyphen in the name.           */
-	/* Generated name renamed from MME-LocationInformation (1600).      */
+	/*                                                                  */
+	/* Change since freeDiameter 1.4.0.                                 */
+	/* Fix: MME-LocationInformation (1600) renamed to MME-Location-Information(1600). */
 	/* MME-Location-Information, Grouped, code 1600, section 7.3.115    */
 	{
@@ -9154,4 +9182,7 @@
 	/* Note: 3GPP TS 29.272 V12.9.0 (2015-12) changed AVP code of       */
 	/* Measurement-Period-LTE (1655) from 1656.                         */
+	/*                                                                  */
+	/* Change since freeDiameter 1.4.0.                                 */
+	/* Fix: Measurement-Period-LTE (1656) code changed from 1656.       */
 	/* Measurement-Period-LTE, Enumerated, code 1655, section 7.3.166   */
 	{
@@ -9172,4 +9203,7 @@
 	/* Note: 3GPP TS 29.272 V12.9.0 (2015-12) changed AVP code of       */
 	/* Measurement-Period-UMTS (1656) from 1655.                        */
+	/*                                                                  */
+	/* Change since freeDiameter 1.4.0.                                 */
+	/* Fix: Measurement-Period-UMTS (1656) code changed from 1655.      */
 	/* Measurement-Period-UMTS, Enumerated, code 1656, section 7.3.167  */
 	{
@@ -10488,5 +10522,8 @@
 
 	/* Note: Name conflict with 3GPP TS 29.229 User-Data (606).         */
-	/* User-Data (702) renamed to User-Data-29.329 (702).               */
+	/* 3GPP TS 29.229 V6.2.0 (2004-09) allocated User-Data (606).       */
+	/* 3GPP TS 29.329 V6.2.0 (2004-09) allocated User-Data (702).       */
+	/*                                                                  */
+	/* Fix: User-Data (702) renamed to User-Data-29.329 (702).          */
 	/* User-Data-29.329, OctetString, code 702, section 6.3.3           */
 	{
@@ -10695,4 +10732,7 @@
 	};
 
+	/* Note: Name conflict with 3GPP TS 29.140 Sequence-Number (1107).  */
+	/* 3GPP TS 29.140 V6.1.0 (2005-06) allocated Sequence-Number (1107). */
+	/* 3GPP TS 29.329 V10.0.0 (2010-09) CR 0163 added Sequence-Number (716). */
 	/* Sequence-Number, Unsigned32, code 716, section 6.3.25            */
 	{
@@ -10950,4 +10990,6 @@
 	};
 
+	/* Note: 3GPP TS 29.061 External-Identifier (28) OctetString replaced by */
+	/* 3GPP TS 29.336 External-Identifier (3111) UTF8String.            */
 	/* External-Identifier, UTF8String, code 3111, section 6.4.11       */
 	{
@@ -13638,5 +13680,8 @@
 
 	/* Note: Name conflict with 3GPP TS 29.212 3GPP-PS-Data-Off-Status (2847). */
-	/* 3GPP-PS-Data-Off-Status (4406) renamed to 3GPP-PS-Data-Off-Status-32.299 (4406). */
+	/* 3GPP TS 29.212 V14.3.0 (2017-03) CR 1559 added 3GPP-PS-Data-Off-Status (2847). */
+	/* 3GPP TS 32.299 V14.3.0 (2017-03) CR 0760 added 3GPP-PS-Data-Off-Status (4406). */
+	/*                                                                  */
+	/* Fix: 3GPP-PS-Data-Off-Status (4406) renamed to 3GPP-PS-Data-Off-Status-32.299 (4406). */
 	/* 3GPP-PS-Data-Off-Status-32.299, Enumerated, code 4406            */
 	{
@@ -15725,4 +15770,7 @@
 	/* Note: 3GPP TS 32.299 V11.8.0 (2013-07) renamed                   */
 	/* LCS-Requestor-Id (1239) to LCS-Requestor-ID (1239).              */
+	/*                                                                  */
+	/* Change since freeDiameter 1.4.0.                                 */
+	/* Fix: LCS-Requestor-Id (1239) renamed to LCS-Requestor-ID (1239). */
 	/* LCS-Requestor-ID, Grouped, code 1239                             */
 	{
@@ -15740,4 +15788,7 @@
 	/* Note: 3GPP TS 32.299 V11.8.0 (2013-07) renamed                   */
 	/* LCS-Requestor-Id-String (1240) to LCS-Requestor-ID-String (1240). */
+	/*                                                                  */
+	/* Change since freeDiameter 1.4.0.                                 */
+	/* Fix: LCS-Requestor-Id-String (1240) renamed to LCS-Requestor-ID-String (1240). */
 	/* LCS-Requestor-ID-String, UTF8String, code 1240                   */
 	{
@@ -15887,5 +15938,7 @@
 	/* Note: 3GPP TS 32.299 V11.8.0 (2013-07) table 7.2 changed         */
 	/* row MBMS-GW-Address (2307) to have a hyphen instead of space.    */
-	/* Generated name renamed from MBMSGW-Address (2307).               */
+	/*                                                                  */
+	/* Change since freeDiameter 1.4.0.                                 */
+	/* Fix: MBMSGW-Address (2307) renamed to MBMS-GW-Address (2307).    */
 	/* MBMS-GW-Address, Address, code 2307                              */
 	{
@@ -16934,4 +16987,7 @@
 	/* Note: 3GPP TS 32.299 V13.1.0 (2015-06) renamed                   */
 	/* PoC-User-Role-info-Units (1254) to PoC-User-Role-Info-Units (1254). */
+	/*                                                                  */
+	/* Change since freeDiameter 1.4.0.                                 */
+	/* Fix: PoC-User-Role-info-Units (1254) renamed to PoC-User-Role-Info-Units (1254). */
 	/* PoC-User-Role-Info-Units, Enumerated, code 1254                  */
 	{
@@ -17610,4 +17666,7 @@
 	};
 
+	/* Note: Name conflict with 3GPP TS 32.299 Recipient-Address (1201); */
+	/* 3GPP TS 29.140 V6.1.0 (2005-06) allocated Recipient-Address (1108). */
+	/* 3GPP TS 32.299 V6.4.0 (2005-09) CR 0028 added Recipient-Address (1201). */
 	/* Recipient-Address, Grouped, code 1201                            */
 	{
@@ -18575,8 +18634,11 @@
 	};
 
-	/* Note: 3GPP TS 32.299 V11.10.0 (2013-12) renamed                  */
-	/* Status (2702) to Status-Code (2702), and then                    */
-	/* 3GPP TS 32.299 V11.14.0 (2014-12) renamed                        */
+	/* Note: 3GPP TS 32.299 V11.10.0 (2013-12) CR 0566 renamed          */
+	/* Status (2702) to Status-Code (2702).                             */
+	/* 3GPP TS 32.299 V11.14.0 (2014-12) CR 0617 renamed                */
 	/* Status-Code (2702) to Status-AS-Code (2702).                     */
+	/*                                                                  */
+	/* Change since freeDiameter 1.4.0.                                 */
+	/* Fix: Status (2702) renamed to Status-AS-Code (2702).             */
 	/* Status-AS-Code, Enumerated, code 2702                            */
 	{
@@ -19439,5 +19501,6 @@
 	};
 
-	/* Note: Application-Service-Type (2102) corrected from UTF8String to Enumerated. */
+	/* Change since freeDiameter 1.4.0.                                 */
+	/* Fix: Application-Service-Type (2102) type changed from UTF8String to Enumerated. */
 	/* Application-Service-Type, Enumerated, code 2102, section 8.4     */
 	{
@@ -19456,5 +19519,6 @@
 	};
 
-	/* Note: Application–Session–Id (2103) corrected from UTF8String to Unsigned32. */
+	/* Change since freeDiameter 1.4.0.                                 */
+	/* Fix: Application–Session–Id (2103) type changed from UTF8String to Unsigned32. */
 	/* Application-Session-Id, Unsigned32, code 2103, section 8.4       */
 	{
@@ -19608,5 +19672,7 @@
 	/*==================================================================*/
 
-	/* Note: 3GPP2-BSID (9010) corrected from OctetString to UTF8String. */
+	/*                                                                  */
+	/* Change since freeDiameter 1.4.0.                                 */
+	/* Fix: 3GPP2-BSID (9010) type changed from OctetString to UTF8String. */
 	/* 3GPP2-BSID, UTF8String, code 9010, section 5.6.2.1.1             */
 	{
Index: extensions/dict_dcca_3gpp/dict_dcca_3gpp.csv
===================================================================
--- extensions/dict_dcca_3gpp/dict_dcca_3gpp.csv	(revision 1510)
+++ extensions/dict_dcca_3gpp/dict_dcca_3gpp.csv	(revision 1511)
@@ -21,5 +21,5 @@
 # Note: 3GPP-IMSI (1) changed to Must M.,,,,,,,
 3GPP-IMSI,1,16.4.7,UTF8String,"M,V",P,,
-"# Note: 3GPP-Charging-Id (2) type changed from OctetString to Unsigned32,",,,,,,,
+"# Fix: 3GPP-Charging-Id (2) type changed from OctetString to Unsigned32,",,,,,,,
 # per 3GPP TS 29.061 clause 16.4.7.2/2 and packet dumps.,,,,,,,
 3GPP-Charging-Id,2,16.4.7,Unsigned32,"M,V",P,,
@@ -46,21 +46,21 @@
 3GPP-Charging-Characteristics,13,16.4.7,UTF8String,"M,V",P,,
 # Note: 3GPP TS 29.061 V12.6.0 (2014-06) renamed,,,,,,,
-# 3GPP-CG-IPv6-Address (14) to 3GPP-CG-Ipv6-Address.,,,,,,,
-# This rename was not applied.,,,,,,,
+# 3GPP-CG-IPv6-Address (14) to 3GPP-CG-Ipv6-Address;,,,,,,,
+# this rename was not applied.,,,,,,,
 # 3GPP-CG-IPv6-Address (14) changed to Must M per contrib/3gpp.,,,,,,,
 3GPP-CG-IPv6-Address,14,16.4.7,OctetString,"M,V",P,,
 # Note: 3GPP TS 29.061 V12.6.0 (2014-06) renamed,,,,,,,
-# 3GPP-SGSN-IPv6-Address (15) to 3GPP-SGSN-Ipv6-Address.,,,,,,,
-# This rename was not applied.,,,,,,,
+# 3GPP-SGSN-IPv6-Address (15) to 3GPP-SGSN-Ipv6-Address;,,,,,,,
+# this rename was not applied.,,,,,,,
 # 3GPP-SGSN-IPv6-Address (15) changed to Must M per contrib/3gpp.,,,,,,,
 3GPP-SGSN-IPv6-Address,15,16.4.7,OctetString,"M,V",P,,
 # Note: 3GPP TS 29.061 V12.6.0 (2014-06) renamed,,,,,,,
-# 3GPP-GGSN-IPv6-Address (16) to 3GPP-GGSN-Ipv6-Address.,,,,,,,
-# This rename was not applied.,,,,,,,
+# 3GPP-GGSN-IPv6-Address (16) to 3GPP-GGSN-Ipv6-Address;,,,,,,,
+# this rename was not applied.,,,,,,,
 # 3GPP-GGSN-IPv6-Address (16) changed to Must M per contrib/3gpp.,,,,,,,
 3GPP-GGSN-IPv6-Address,16,16.4.7,OctetString,"M,V",P,,
 # Note: 3GPP TS 29.061 V12.6.0 (2014-06) renamed,,,,,,,
-# 3GPP-IPv6-DNS-Servers (17) to 3GPP-Ipv6-DNS-Servers.,,,,,,,
-# This rename was not applied.,,,,,,,
+# 3GPP-IPv6-DNS-Servers (17) to 3GPP-Ipv6-DNS-Servers;,,,,,,,
+# this rename was not applied.,,,,,,,
 # 3GPP-IPv6-DNS-Servers (17) changed to Must M per contrib/3gpp.,,,,,,,
 3GPP-IPv6-DNS-Servers,17,16.4.7,OctetString,"M,V",P,,
@@ -80,11 +80,10 @@
 3GPP-Allocate-IP-Type,27,16.4.7,OctetString,V,P,,M
 # Note: 3GPP TS 29.061 table 9a does not define,,,,,,,
-# External-Identifier (28) for Diameter.,,,,,,,
+# External-Identifier (28) for Diameter; it is RADIUS only.,,,,,,,
 # 3GPP TS 29.061 table 9b refers to 3GPP TS 29.336,,,,,,,
 # for External-Identifier (3111).,,,,,,,
 # ,,,,,,,
-# External-Identifier (28) OctetString replaced by,,,,,,,
-# External-Identifier (3111) UTF8String.,,,,,,,
-#,,,,,,,
+# Change since freeDiameter 1.4.0.,,,,,,,
+# Fix: Remove External-Identifier (28) OctetString.,,,,,,,
 #,,,,,,,
 TWAN-Identifier,29,16.4.7,OctetString,V,P,,M
@@ -113,11 +112,11 @@
 MBMS-GGSN-Address,916,17.7.19,OctetString,"M,V",P,,
 # Note: 3GPP TS 29.061 V12.6.0 (2014-06) renamed,,,,,,,
-# MBMS-GGSN-IPv6-Address (917) to MBMS-GGSN-Ipv6-Address.,,,,,,,
-# This rename was not applied.,,,,,,,
+# MBMS-GGSN-IPv6-Address (917) to MBMS-GGSN-Ipv6-Address;,,,,,,,
+# this rename was not applied.,,,,,,,
 MBMS-GGSN-IPv6-Address,917,17.7.20,OctetString,"M,V",P,,
 MBMS-BMSC-SSM-IP-Address,918,17.7.21,OctetString,"M,V",P,,
 # Note: 3GPP TS 29.061 V12.6.0 (2014-06) renamed,,,,,,,
-# MBMS-BMSC-SSM-IPv6-Address (919) to MBMS-BMSC-SSM-Ipv6-Address.,,,,,,,
-# This rename was not applied.,,,,,,,
+# MBMS-BMSC-SSM-IPv6-Address (919) to MBMS-BMSC-SSM-Ipv6-Address;,,,,,,,
+# this rename was not applied.,,,,,,,
 MBMS-BMSC-SSM-IPv6-Address,919,17.7.22,OctetString,"M,V",P,,
 MBMS-Flow-Identifier,920,17.7.23,OctetString,"M,V",P,,
@@ -131,6 +130,6 @@
 MBMS-GW-SSM-IP-Address,924,20.5a.2,OctetString,V,P,,M
 # Note: 3GPP TS 29.061 V12.6.0 (2014-06) renamed,,,,,,,
-# MBMS-GW-SSM-IPv6-Address (925) to MBMS-GW-SSM-Ipv6-Address.,,,,,,,
-# This rename was not applied.,,,,,,,
+# MBMS-GW-SSM-IPv6-Address (925) to MBMS-GW-SSM-Ipv6-Address;,,,,,,,
+# this rename was not applied.,,,,,,,
 MBMS-GW-SSM-IPv6-Address,925,20.5a.3,OctetString,V,P,,M
 MBMS-BMSC-SSM-UDP-Port,926,20.5a.4,OctetString,V,P,,M
@@ -169,6 +168,4 @@
 UE-Count,4308,6.4.13,Unsigned32,"M,V",,,
 Connection-Action,4314,6.4.18,Unsigned32,"M,V",,,
-# Note: 3GPP TS 29.128 table 6.4.1-1 row Non-IP-Data (4315),,,,,,,
-"# has type ""Octetstring"" instead of ""OctetString"".",,,,,,,
 Non-IP-Data,4315,6.4.19,OctetString,"M,V",,,
 Serving-PLMN-Rate-Control,4310,6.4.21,Grouped,"M,V",,,
@@ -208,9 +205,15 @@
 Initial-Recipient-Address,1105,6.3.8,Grouped,"M,V",,,
 Result-Recipient-Address,1106,6.3.9,Grouped,"M,V",,,
-# Note: Name conflict with 3GPP TS 32.329 Sequence-Number (716).,,,,,,,
-# Sequence-Number (1107) renamed to Sequence-Number-29.140 (1107).,,,,,,,
+# Note: Name conflict with 3GPP TS 29.329 Sequence-Number (716).,,,,,,,
+# 3GPP TS 29.140 V6.1.0 (2005-06) allocated Sequence-Number (1107).,,,,,,,
+# 3GPP TS 29.329 V10.0.0 (2010-09) CR 0163 added Sequence-Number (716).,,,,,,,
+# ,,,,,,,
+# Fix: Sequence-Number (1107) renamed to Sequence-Number-29.140 (1107).,,,,,,,
 Sequence-Number-29.140,1107,6.3.10,Unsigned32,"M,V",,,
-# Note: Name conflict with 3GPP TS 32.299 Recipient-Address (1201).,,,,,,,
-# Recipient-Address (1108) renamed to Recipient-Address-29.140 (1108).,,,,,,,
+# Note: Name conflict with 3GPP TS 32.299 Recipient-Address (1201);,,,,,,,
+# 3GPP TS 29.140 V6.1.0 (2005-06) allocated Recipient-Address (1108).,,,,,,,
+# 3GPP TS 32.299 V6.4.0 (2005-09) CR 0028 added Recipient-Address (1201).,,,,,,,
+# ,,,,,,,
+# Fix: Recipient-Address (1108) renamed to Recipient-Address-29.140 (1108).,,,,,,,
 Recipient-Address-29.140,1108,6.3.11,UTF8String,"M,V",,,
 Routeing-Address,1109,6.3.12,UTF8String,"M,V",,,
@@ -221,6 +224,12 @@
 Service-Key,1114,6.3.17,UTF8String,"M,V",,,
 Billing-Information,1115,6.3.18,UTF8String,"M,V",,,
-# Note: Name conflict with 3GPP TS 32.299 Status (2702).,,,,,,,
-# Status (1116) renamed to Status-29.140 (1116).,,,,,,,
+# Note: Name conflict with 3GPP TS 32.299 V11.6.0 Status (2702).,,,,,,,
+# 3GPP TS 32.299 V11.10.0 (2013-12) CR 0566 renamed,,,,,,,
+# Status (2702) to Status-Code (2702).,,,,,,,
+# 3GPP TS 32.299 V11.14.0 (2014-12) CR 0617 renamed,,,,,,,
+# Status-Code (2702) to Status-AS-Code (2702).,,,,,,,
+# ,,,,,,,
+# TODO: rename back to Status ?,,,,,,,
+# Fix: Status (1116) renamed to Status-29.140 (1116).,,,,,,,
 Status-29.140,1116,6.3.19,Grouped,"M,V",,,
 Status-Code,1117,6.3.20,UTF8String,"M,V",,,
@@ -248,5 +257,6 @@
 # Time-Window (3818) in 3GPP TS 29.345 V12.1.0 (2014-12) predates,,,,,,,
 # Time-Window (4204) in 3GPP TS 29.154 V13.1.0 (2016-03).,,,,,,,
-# Time-Window (4204) renamed to Time-Window-29.154 (4204).,,,,,,,
+# ,,,,,,,
+# Fix: Time-Window (4204) renamed to Time-Window-29.154 (4204).,,,,,,,
 Time-Window-29.154,4204,5.3.5,Grouped,"M,V",P,,
 Transfer-End-Time,4205,5.3.6,Time,"M,V",P,,
@@ -424,4 +434,7 @@
 # Note: 3GPP TS 29.212 V12.1.0 (2013-06) removed ADC-Revalidation-Time (2801).,,,,,,,
 ADC-Revalidation-Time,2801,5.3.93,Time,V,P,,M
+# Note: Name conflict with 3GPP TS 32.299 3GPP-PS-Data-Off-Status (4406).,,,,,,,
+# 3GPP TS 29.212 V14.3.0 (2017-03) CR 1559 added 3GPP-PS-Data-Off-Status (2847).,,,,,,,
+# 3GPP TS 32.299 V14.3.0 (2017-03) CR 0760 added 3GPP-PS-Data-Off-Status (4406).,,,,,,,
 3GPP-PS-Data-Off-Status,2847,5.3.133,Enumerated,V,P,,M
 Access-Availability-Change-Reason,2833,5.3.121,Unsigned32,V,P,,M
@@ -636,7 +649,11 @@
 # Note: 3GPP TS 29.214 table 5.3.0.1 row IMS-Content-Identifier (563),,,,,,,
 "# missing M, assume MUST NOT.",,,,,,,
+# ,,,,,,,
+# Fix: IMS-Content-Identifier (563) flag M MUST NOT.,,,,,,,
 IMS-Content-Identifier,563,5.3.60,OctetString,V,P,,M
 # Note: 3GPP TS 29.214 table 5.3.0.1 row IMS-Content (564),,,,,,,
 "# missing M, assume MUST NOT.",,,,,,,
+# ,,,,,,,
+# Fix: IMS-Content (564) flag M MUST NOT.,,,,,,,
 IMS-Content-Type,564,5.3.61,Enumerated,V,P,,M
 IP-Domain-Id,537,5.3.35,OctetString,V,P,,M
@@ -755,4 +772,7 @@
 Mandatory-Capability,604,6.3.5,Unsigned32,"M, V",,,
 Optional-Capability,605,6.3.6,Unsigned32,"M, V",,,
+# Note: Name conflict with 3GPP TS 29.329 User-Data (702).,,,,,,,
+# 3GPP TS 29.229 V6.2.0 (2004-09) allocated User-Data (606).,,,,,,,
+# 3GPP TS 29.329 V6.2.0 (2004-09) allocated User-Data (702).,,,,,,,
 User-Data,606,6.3.7,OctetString,"M, V",,,
 SIP-Number-Auth-Items,607,6.3.8,Unsigned32,"M, V",,,
@@ -901,4 +921,7 @@
 # changed row SS-Status (1477) to be OctetString instead of Grouped.,,,,,,,
 # Clause 7.3.88 already described SS-Status (1147) as OctetString.,,,,,,,
+# ,,,,,,,
+# Change since freeDiameter 1.4.0.,,,,,,,
+# Fix: SS-Status (1477) type changed from Grouped to OctetString.,,,,,,,
 SS-Status,1477,7.3.88,OctetString,"M,V",,,
 Notification-To-UE-User,1478,7.3.89,Enumerated,"M,V",,,
@@ -914,4 +937,7 @@
 # Note: 3GPP TS 29.272 V12.4.0 (2014-03) renamed,,,,,,,
 # Call-Barring-Infor-List (1488) to Call-Barring-Info (1488).,,,,,,,
+# ,,,,,,,
+# Change since freeDiameter 1.4.0.,,,,,,,
+# Fix: Call-Barring-Infor-List (1488) renamed to Call-Barring-Info (1488).,,,,,,,
 Call-Barring-Info,1488,7.3.101,Grouped,"M,V",,,
 SGSN-Number,1489,7.3.102,OctetString,"M,V",,,
@@ -928,5 +954,7 @@
 # Note: 3GPP TS 29.272 table 7.3.1/1 row MME-Location-Information (1600),,,,,,,
 # incorrectly has a space instead of hyphen in the name.,,,,,,,
-# Generated name renamed from MME-LocationInformation (1600).,,,,,,,
+# ,,,,,,,
+# Change since freeDiameter 1.4.0.,,,,,,,
+# Fix: MME-LocationInformation (1600) renamed to MME-Location-Information(1600).,,,,,,,
 MME-Location-Information,1600,7.3.115,Grouped,V,,,M
 SGSN-Location-Information,1601,7.3.116,Grouped,V,,,M
@@ -980,7 +1008,13 @@
 # Note: 3GPP TS 29.272 V12.9.0 (2015-12) changed AVP code of,,,,,,,
 # Measurement-Period-LTE (1655) from 1656.,,,,,,,
+# ,,,,,,,
+# Change since freeDiameter 1.4.0.,,,,,,,
+# Fix: Measurement-Period-LTE (1656) code changed from 1656.,,,,,,,
 Measurement-Period-LTE,1655,7.3.166,Enumerated,V,,,M
 # Note: 3GPP TS 29.272 V12.9.0 (2015-12) changed AVP code of,,,,,,,
 # Measurement-Period-UMTS (1656) from 1655.,,,,,,,
+# ,,,,,,,
+# Change since freeDiameter 1.4.0.,,,,,,,
+# Fix: Measurement-Period-UMTS (1656) code changed from 1655.,,,,,,,
 Measurement-Period-UMTS,1656,7.3.167,Enumerated,V,,,M
 Collection-Period-RRM-LTE,1657,7.3.168,Enumerated,V,,,M
@@ -1157,5 +1191,8 @@
 MSISDN,701,6.3.2,OctetString,"M, V",,,
 # Note: Name conflict with 3GPP TS 29.229 User-Data (606).,,,,,,,
-# User-Data (702) renamed to User-Data-29.329 (702).,,,,,,,
+# 3GPP TS 29.229 V6.2.0 (2004-09) allocated User-Data (606).,,,,,,,
+# 3GPP TS 29.329 V6.2.0 (2004-09) allocated User-Data (702).,,,,,,,
+# ,,,,,,,
+# Fix: User-Data (702) renamed to User-Data-29.329 (702).,,,,,,,
 User-Data-29.329,702,6.3.3,OctetString,"M, V",,,
 Data-Reference,703,6.3.4,Enumerated,"M, V",,,
@@ -1172,4 +1209,7 @@
 Serving-Node-Indication,714,6.3.23,Enumerated,V,,,M
 Repository-Data-ID,715,6.3.24,Grouped,V,,,M
+# Note: Name conflict with 3GPP TS 29.140 Sequence-Number (1107).,,,,,,,
+# 3GPP TS 29.140 V6.1.0 (2005-06) allocated Sequence-Number (1107).,,,,,,,
+# 3GPP TS 29.329 V10.0.0 (2010-09) CR 0163 added Sequence-Number (716).,,,,,,,
 Sequence-Number,716,6.3.25,Unsigned32,V,,,M
 Pre-paging-Supported,717,6.3.26,Enumerated,V,,,M
@@ -1204,4 +1244,6 @@
 HSS-Cause,3109,6.4.9,Unsigned32,"M,V",,,
 SIR-Flags,3110,6.4.10,Unsigned32,"M,V",,,
+# Note: 3GPP TS 29.061 External-Identifier (28) OctetString replaced by,,,,,,,
+# 3GPP TS 29.336 External-Identifier (3111) UTF8String.,,,,,,,
 External-Identifier,3111,6.4.11,UTF8String,"M,V",,,
 IP-SM-GW-Realm,3112,6.4.18,DiameterIdentity,"M,V",,,
@@ -1501,5 +1543,8 @@
 3GPP-OC-Request-Type,1322,,Enumerated,V,,,M
 # Note: Name conflict with 3GPP TS 29.212 3GPP-PS-Data-Off-Status (2847).,,,,,,,
-# 3GPP-PS-Data-Off-Status (4406) renamed to 3GPP-PS-Data-Off-Status-32.299 (4406).,,,,,,,
+# 3GPP TS 29.212 V14.3.0 (2017-03) CR 1559 added 3GPP-PS-Data-Off-Status (2847).,,,,,,,
+# 3GPP TS 32.299 V14.3.0 (2017-03) CR 0760 added 3GPP-PS-Data-Off-Status (4406).,,,,,,,
+# ,,,,,,,
+# Fix: 3GPP-PS-Data-Off-Status (4406) renamed to 3GPP-PS-Data-Off-Status-32.299 (4406).,,,,,,,
 3GPP-PS-Data-Off-Status-32.299,4406,,Enumerated,"V,M",,,
 Access-Network-Info-Change,4401,,Grouped,"V,M",,,
@@ -1656,7 +1701,13 @@
 # Note: 3GPP TS 32.299 V11.8.0 (2013-07) renamed,,,,,,,
 # LCS-Requestor-Id (1239) to LCS-Requestor-ID (1239).,,,,,,,
+# ,,,,,,,
+# Change since freeDiameter 1.4.0.,,,,,,,
+# Fix: LCS-Requestor-Id (1239) renamed to LCS-Requestor-ID (1239).,,,,,,,
 LCS-Requestor-ID,1239,,Grouped,"V,M",,,
 # Note: 3GPP TS 32.299 V11.8.0 (2013-07) renamed,,,,,,,
 # LCS-Requestor-Id-String (1240) to LCS-Requestor-ID-String (1240).,,,,,,,
+# ,,,,,,,
+# Change since freeDiameter 1.4.0.,,,,,,,
+# Fix: LCS-Requestor-Id-String (1240) renamed to LCS-Requestor-ID-String (1240).,,,,,,,
 LCS-Requestor-ID-String,1240,,UTF8String,"V,M",,,
 Local-GW-Inserted-Indication,2604,,Enumerated,"V,M",,,
@@ -1671,5 +1722,7 @@
 # Note: 3GPP TS 32.299 V11.8.0 (2013-07) table 7.2 changed,,,,,,,
 # row MBMS-GW-Address (2307) to have a hyphen instead of space.,,,,,,,
-# Generated name renamed from MBMSGW-Address (2307).,,,,,,,
+# ,,,,,,,
+# Change since freeDiameter 1.4.0.,,,,,,,
+# Fix: MBMSGW-Address (2307) renamed to MBMS-GW-Address (2307).,,,,,,,
 MBMS-GW-Address,2307,,Address,"V,M",,,
 MBMS-Information,880,,Grouped,"V,M",,,
@@ -1752,4 +1805,7 @@
 # Note: 3GPP TS 32.299 V13.1.0 (2015-06) renamed,,,,,,,
 # PoC-User-Role-info-Units (1254) to PoC-User-Role-Info-Units (1254).,,,,,,,
+# ,,,,,,,
+# Change since freeDiameter 1.4.0.,,,,,,,
+# Fix: PoC-User-Role-info-Units (1254) renamed to PoC-User-Role-Info-Units (1254).,,,,,,,
 PoC-User-Role-Info-Units,1254,,Enumerated,"V,M",,,
 Positioning-Data,1245,,UTF8String,"V,M",,,
@@ -1801,4 +1857,7 @@
 Received-Talk-Burst-Time,1284,,Unsigned32,"V,M",,,
 Received-Talk-Burst-Volume,1285,,Unsigned32,"V,M",,,
+# Note: Name conflict with 3GPP TS 32.299 Recipient-Address (1201);,,,,,,,
+# 3GPP TS 29.140 V6.1.0 (2005-06) allocated Recipient-Address (1108).,,,,,,,
+# 3GPP TS 32.299 V6.4.0 (2005-09) CR 0028 added Recipient-Address (1201).,,,,,,,
 Recipient-Address,1201,,Grouped,"V,M",,,
 Recipient-Info,2026,,Grouped,"V,M",,,
@@ -1872,8 +1931,11 @@
 Start-of-Charging,3419,,Time,"V,M",,,
 Start-Time,2041,,Time,"V,M",,,
-# Note: 3GPP TS 32.299 V11.10.0 (2013-12) renamed,,,,,,,
-"# Status (2702) to Status-Code (2702), and then",,,,,,,
-# 3GPP TS 32.299 V11.14.0 (2014-12) renamed,,,,,,,
+# Note: 3GPP TS 32.299 V11.10.0 (2013-12) CR 0566 renamed,,,,,,,
+# Status (2702) to Status-Code (2702).,,,,,,,
+# 3GPP TS 32.299 V11.14.0 (2014-12) CR 0617 renamed,,,,,,,
 # Status-Code (2702) to Status-AS-Code (2702).,,,,,,,
+# ,,,,,,,
+# Change since freeDiameter 1.4.0.,,,,,,,
+# Fix: Status (2702) renamed to Status-AS-Code (2702).,,,,,,,
 Status-AS-Code,2702,,Enumerated,"V,M",,,
 Stop-Time,2042,,Time,"V,M",,,
@@ -1955,7 +2017,9 @@
 #,,,,,,,
 Application-Server-Id,2101,8.4,UTF8String,"M,V",,,
-# Note: Application-Service-Type (2102) corrected from UTF8String to Enumerated.,,,,,,,
+# Change since freeDiameter 1.4.0.,,,,,,,
+# Fix: Application-Service-Type (2102) type changed from UTF8String to Enumerated.,,,,,,,
 Application-Service-Type,2102,8.4,Enumerated,"M,V",,,
-# Note: Application–Session–Id (2103) corrected from UTF8String to Unsigned32.,,,,,,,
+# Change since freeDiameter 1.4.0.,,,,,,,
+# Fix: Application–Session–Id (2103) type changed from UTF8String to Unsigned32.,,,,,,,
 Application-Session-Id,2103,8.4,Unsigned32,"M,V",,,
 Content-ID,2116,8.4,UTF8String,"M,V",,,
@@ -1982,4 +2046,6 @@
 #=,,,,,,,
 #,,,,,,,
-# Note: 3GPP2-BSID (9010) corrected from OctetString to UTF8String.,,,,,,,
+# ,,,,,,,
+# Change since freeDiameter 1.4.0.,,,,,,,
+# Fix: 3GPP2-BSID (9010) type changed from OctetString to UTF8String.,,,,,,,
 3GPP2-BSID,9010,5.6.2.1.1,UTF8String,"M,V",P,,
